module Subledger
  module Domain
    module Roles
      module Describable
        attr_accessor :description, :reference

        def self.raise_unless_creatable args
          description = args[:description]

          if description.nil? or not description.kind_of? String
            raise DescribableError, ':description is required and must be a String'
          end

          reference = args[:reference]

          if not reference.nil? and reference !~ URI.regexp
            raise DescribableError, ':reference must be a URL'
          end
        end

        private

        def describable args
          description  = args[:description]
          @description = description.nil? ? nil : description.encode('UTF-8')

          reference  = args[:reference]
          @reference = reference.nil? ? nil : reference.encode('UTF-8')
        end
      end
    end
  end
end
