module Subledger
  module Domain
    module Roles
      module Readable
        def self.included base
          base.extend ReadableClass
        end

        module ReadableClass
          def read args
            unless args[:id]
              raise ReadableError, 'Cannot read without :id'
            end

            readable = args[:client].send collection_name, args

            args[:store].read readable
          end
        end

        def read
          readable = self.class.read attributes

          if self.class == readable.class
            initialize readable.attributes
            self
          else
            readable
          end
        end
      end
    end
  end
end
