module Subledger
  module Domain
    module Roles
      module Storable
        attr_reader :store, :client

        def self.raise_unless_creatable args
          store = args[:store]

          if store.nil? or not store.kind_of? Store
            raise StorableError, ':store is required and must be a Store'
          end

          client = args[:client]

          if client.nil? or not client.kind_of? Interface::Client
            raise StorableError, ':client is required and must be a Client'
          end
        end

        private

        def storable args
          @store  = args[:store]
          @client = args[:client]
        end
      end
    end
  end
end
