module Subledger
  module Domain
    module Roles
      module Updatable
        def self.included base
          base.extend UpdatableClass
        end

        module UpdatableClass
          def update args
            client = args[:client]

            updatable = client.send collection_name, args

            args[:store].update updatable
          end
        end

        def update
          updatable = dup

          updatable.send :increment_version

          args = updatable.attributes

          updated = self.class.update args

          initialize updated.attributes

          self
        end
      end
    end
  end
end
