module Subledger
  module Domain
    module Roles
      module Versionable
        def self.included base
          base.extend VersionableClass
        end

        module VersionableClass
          def self.raise_unless_creatable args
            version = args[:version]

            if version.nil? or not version.kind_of? Fixnum
              raise VersionableError, ':version is required and must be a Fixnum'
            end
          end
        end

        attr_reader :version

        protected

        private

        def versionable args
          @version = args[:version] || 1
        end

        def increment_version
          @version += 1
        end
      end
    end
  end
end
