module Subledger
  module Domain
    class Zero

      include Value

      def self.type
        'zero'
      end

      def rest_hash
        { 'type' => 'zero', 'amount' => amount_to_s(@amount) }
      end

      private

      def validate_sign arg_amount
        unless arg_amount.zero?
          raise ValueError, 'Amount must be zero'
        end
      end
    end
  end
end
