module Subledger
  module Store
    module Api
      module Balance
        def account_balance args
          client  = args[:client]
          account = args[:account]
          at      = args[:at].iso8601(3)

          path = Path.for_entity( :anchor => account ) + '/balance?at=' + at

          begin
            response_hash = parse_json(
                              http.get( path ).body )
          rescue Exception => e
            raise BalanceError, "Cannot balance #{account}: #{e}"
          end

          Rest.to_balance response_hash, client
        end

        def journal_entry_balance args
          client        = args[:client]
          journal_entry = args[:journal_entry]

          path = Path.for_entity( :anchor => journal_entry ) + '/balance'

          begin
            response_hash = parse_json( http.get( path ).body )
          rescue Exception => e
            raise BalanceError, "Cannot balance #{journal_entry}: #{e}"
          end

          Rest.to_balance response_hash, client
        end
      end
    end
  end
end
