module Subledger
  module Store
    module Api
      module Collect

        private

        def before args
          collect_with args
        end

        def ending args
          collect_with args
        end

        def starting args
          collect_with args
        end

        def after args
          collect_with args
        end

        def preceding args
          collect_with args
        end

        def following args
          collect_with args
        end

        def collect_with args
          path = Path.for_collect args

          anchor = args[:anchor]

          klass = anchor.class

          begin
            collection = parse_json http.get( path ).body
          rescue Exception => e
            raise CollectError, "Cannot collect: #{e}"
          end

          client = anchor.client

          key = collection.keys.first

          collection[key].collect do |response_hash|
            args = Rest.to_args response_hash, client

            client.send key, args
          end
        end
      end
    end
  end
end
